Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.optaplanner.core.api.score.buildin.hardsoftbigdecimal
Class HardSoftBigDecimalScore

    java.lang.Object
      org.optaplanner.core.api.score.AbstractScore<HardSoftBigDecimalScore>
          org.optaplanner.core.api.score.buildin.hardsoftbigdecimal.HardSoftBigDecimalScore

All Implemented Interfaces:
  Serializable, Comparable<HardSoftBigDecimalScore>, FeasibilityScore<HardSoftBigDecimalScore>, Score<HardSoftBigDecimalScore>

    public final class HardSoftBigDecimalScore

extends AbstractScore<HardSoftBigDecimalScore>
implements FeasibilityScore<HardSoftBigDecimalScore>

This `Score` is based on 2 levels of `BigDecimal` constraints: hard and soft. Hard constraints have priority over soft constraints.

This class is immutable.

See Also:
  `Score`, Serialized Form

Method Summary
`HardSoftBigDecimalScore` | `add(HardSoftBigDecimalScore augment)` Returns a Score whose value is (this + augment).
`int` | `compareTo(HardSoftBigDecimalScore other)`
`HardSoftBigDecimalScore` | `divide(double divisor)` Returns a Score whose value is (this / divisor).
`boolean` | `equals(Object o)`
`BigDecimal` | `getHardScore()` The total of the broken negative hard constraints and fulfilled positive hard constraints.
`BigDecimal` | `getSoftScore()` The total of the broken negative soft constraints and fulfilled positive soft constraints.
`int` | `hashCode()`
`boolean` | `isFeasible()` A `Solution` is feasible if it has no broken hard constraints.
`HardSoftBigDecimalScore` | `multiply(double multiplicand)` Returns a Score whose value is (this * multiplicand).
`static HardSoftBigDecimalScore` | `parseScore(String scoreString)`
`HardSoftBigDecimalScore` | `power(double exponent)` Returns a Score whose value is (this ^ exponent).
`HardSoftBigDecimalScore` | `subtract(HardSoftBigDecimalScore subtrahend)` Returns a Score whose value is (this - subtrahend).
`Number[]` | `toLevelNumbers()` Returns an array of doubles representing the Score.
`String` | `toString()`
`static HardSoftBigDecimalScore` | `valueOf(BigDecimal hardScore, BigDecimal softScore)`

Methods inherited from class org.optaplanner.core.api.score.AbstractScore
`buildScorePattern, buildScorePattern, parseLevelStrings, parseLevelStrings`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Method Detail

### parseScore

    public static HardSoftBigDecimalScore parseScore(String scoreString)

### valueOf

    public static HardSoftBigDecimalScore valueOf(BigDecimal hardScore,
                                                  BigDecimal softScore)

### getHardScore

    public BigDecimal getHardScore()

  The total of the broken negative hard constraints and fulfilled positive hard constraints. Their weight is included in the total. The hard score is usually a negative number because most use cases only have negative constraints.

  Returns:
    higher is better, usually negative, 0 if no hard constraints are broken/fulfilled

### getSoftScore

    public BigDecimal getSoftScore()

  The total of the broken negative soft constraints and fulfilled positive soft constraints. Their weight is included in the total. The soft score is usually a negative number because most use cases only have negative constraints.

  In a normal score comparison, the soft score is irrelevant if the 2 scores don't have the same hard score.

  Returns:
    higher is better, usually negative, 0 if no soft constraints are broken/fulfilled

### isFeasible

    public boolean isFeasible()

  Description copied from interface: `FeasibilityScore`
  A `Solution` is feasible if it has no broken hard constraints.

  Specified by:
    `isFeasible` in interface `FeasibilityScore<HardSoftBigDecimalScore>`
  Returns:
    true if the hard score(s) is 0 or higher

### add

    public HardSoftBigDecimalScore add(HardSoftBigDecimalScore augment)

  Description copied from interface: `Score`
  Returns a Score whose value is (this + augment).

  Specified by:
    `add` in interface `Score<HardSoftBigDecimalScore>`
  Parameters:
    `augment` - value to be added to this Score
  Returns:
    this + augment

### subtract

    public HardSoftBigDecimalScore subtract(HardSoftBigDecimalScore subtrahend)

  Description copied from interface: `Score`
  Returns a Score whose value is (this - subtrahend).

  Specified by:
    `subtract` in interface `Score<HardSoftBigDecimalScore>`
  Parameters:
    `subtrahend` - value to be subtracted from this Score
  Returns:
    this - subtrahend, rounded as necessary

### multiply

    public HardSoftBigDecimalScore multiply(double multiplicand)

  Description copied from interface: `Score`
  Returns a Score whose value is (this * multiplicand). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double multiplicand should have no impact on the returned scale/precision.

  Specified by:
    `multiply` in interface `Score<HardSoftBigDecimalScore>`
  Parameters:
    `multiplicand` - value to be multiplied by this Score.
  Returns:
    this * multiplicand

### divide

    public HardSoftBigDecimalScore divide(double divisor)

  Description copied from interface: `Score`
  Returns a Score whose value is (this / divisor). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double divisor should have no impact on the returned scale/precision.

  Specified by:
    `divide` in interface `Score<HardSoftBigDecimalScore>`
  Parameters:
    `divisor` - value by which this Score is to be divided
  Returns:
    this / divisor

### power

    public HardSoftBigDecimalScore power(double exponent)

  Description copied from interface: `Score`
  Returns a Score whose value is (this ^ exponent). When rounding is needed, it should be floored (as defined by `Math.floor(double)`.

  /> If the implementation has a scale/precision, then the unspecified scale/precision of the double exponent should have no impact on the returned scale/precision.

  Specified by:
    `power` in interface `Score<HardSoftBigDecimalScore>`
  Parameters:
    `exponent` - value by which this Score is to be powered
  Returns:
    this ^ exponent

### toLevelNumbers

    public Number[] toLevelNumbers()

  Description copied from interface: `Score`
  Returns an array of doubles representing the Score. Each double represents 1 score level. A greater score level uses a lower array index than a lesser score level.

  When rounding is needed, each rounding should be floored (as defined by `Math.floor(double)`. The length of the returned array must be stable for a specific `Score` implementation.

  For example: -0hard/-7soft returns new double{-0.0, -7.0}

  Specified by:
    `toLevelNumbers` in interface `Score<HardSoftBigDecimalScore>`
  Returns:
    never null

### equals

    public boolean equals(Object o)

  Overrides:
    `equals` in class `Object`

### hashCode

    public int hashCode()

  Overrides:
    `hashCode` in class `Object`

### compareTo

    public int compareTo(HardSoftBigDecimalScore other)

  Specified by:
    `compareTo` in interface `Comparable<HardSoftBigDecimalScore>`

### toString

    public String toString()

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| OptaPlanner distribution 6.0.0.CR4
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2006-2013 JBoss by Red Hat. All Rights Reserved.